---------
---
--- GoldCounter (GCLib) by Hexiatröhm
---
---------

--------------------------------------------------------------------------------------------------------------

--- Slash Commands
SLASH_GC1, SLASH_GC2 = '/gc', "/goldcounter";
function SlashCmdList.GC(msg, editBox)

	if msg then msg = string.lower( msg ); end
	
	if msg == "options" then

		InterfaceOptionsFrame_OpenToCategory( GoldCounterOptionsPanel );
		InterfaceOptionsFrame_OpenToCategory( GoldCounterOptionsPanel ); --- Double Call because Classic bug
		return;
	end

	if msg == "uiv" then
		DEFAULT_CHAT_FRAME:AddMessage( "|cffffff00UI Version:|r "..GC_WOW_BuildInfo );
		return;
	end
	
	if msg == "query" then

		GC_switchQuery = true;

		local inInstance, instanceType = IsInInstance();
		local isParty = GetNumGroupMembers();

		if inInstance then
			DEFAULT_CHAT_FRAME:AddMessage( "In Instance" );
		else
			DEFAULT_CHAT_FRAME:AddMessage( "NOT in Instance" );
		end
		DEFAULT_CHAT_FRAME:AddMessage( "Party type: "..instanceType );

		if ( inInstance == true ) then

			C_ChatInfo.SendAddonMessage( "GOLDCOUNTER", "QUERY", "INSTANCE_CHAT" );
			DEFAULT_CHAT_FRAME:AddMessage( "|cffffff00Query sent: INSTANCE_CHAT|r" );

		end

		if     instanceType == "raid" then

			C_ChatInfo.SendAddonMessage( "GOLDCOUNTER", "QUERY", "RAID" );
			DEFAULT_CHAT_FRAME:AddMessage( "|cffffff00Query sent: RAID|r" );

		elseif instanceType == "party" then

			C_ChatInfo.SendAddonMessage( "GOLDCOUNTER", "QUERY", "PARTY" );
			DEFAULT_CHAT_FRAME:AddMessage( "|cffffff00Query sent: PARTY|r" );

		elseif instanceType == "pvp" then

			C_ChatInfo.SendAddonMessage( "GOLDCOUNTER", "QUERY", "BATTLEGROUND" );
			DEFAULT_CHAT_FRAME:AddMessage( "|cffffff00Query sent: BATTLEGROUND-PVP|r" );

		elseif ( isParty > 0 ) then

			C_ChatInfo.SendAddonMessage( "GOLDCOUNTER", "QUERY", "RAID" );
			DEFAULT_CHAT_FRAME:AddMessage( "|cffffff00Query sent: PARTY-RAID|r" );

		end

		return;

	elseif msg == "queryg" then

		if ( IsInGuild() ) then

		GC_switchQuery = true;

			C_ChatInfo.SendAddonMessage( "GOLDCOUNTER", "QUERY", "GUILD" );
			DEFAULT_CHAT_FRAME:AddMessage( "|cffffff00Query sent: GUILD|r" );

		else

			DEFAULT_CHAT_FRAME:AddMessage( "|cffffff00Not in a guild|r" );

		end

		return;
	end

	DEFAULT_CHAT_FRAME:AddMessage( "|cffffff00GoldCounter|r version "..GC_Version.." by Hexiatröhm" );
	DEFAULT_CHAT_FRAME:AddMessage( "|cffffff00     /gc options|r  "..GC_Locale_Text.CHAT_OPTIONS );
	
end

--------------------------------------------------------------------------------------------------------------

function GoldCounter_Reset( AutoReset, FirstInit )

	if ( MySavedMoney ~= 0 ) then

		-- Remember balance for history tooltip
		local mydate = date("%y/%m/%d  %H:%M")
		local amount = GetCoinTextureString( abs( MySavedMoney ), 12 );
		----

		-- Shift table for history tooltip
	 	if MySavedMoneyHistory[1] then

			--- if History entry then shift table
			for i = My_GC_Settings_Local.MaxHistoryRec - 1, 1, -1 do

				MySavedMoneyHistory[i+1].date = MySavedMoneyHistory[i].date;
				MySavedMoneyHistory[i+1].amount = MySavedMoneyHistory[i].amount;

			end
		end
		----

		-- Set most recent reset amount
		amount = MyMoney.Color..MyMoney.Sign..amount.."|r";

		MySavedMoneyHistory[1].date = mydate;
		MySavedMoneyHistory[1].amount = amount;
		----

	PlaySound( SOUNDKIT.IG_BACKPACK_COIN_SELECT );

	end

	GC_MyAsset = GetMoney(); -- Get new current funds to balance

	--- Always true to keep the "00" at first init
	MySavedMoney	= 0;
	MyMoney.Gold	= "0";
	MyMoney.Silver	= "00";
	MyMoney.Copper	= "00";
	MyMoney.Sign	= " ";
	MyMoney.Color	= Money_NoColor;

	if AutoReset == false then
	DEFAULT_CHAT_FRAME:AddMessage( "|cffffff00GoldCounter|r "..GC_Locale_Text.CHAT_COUNT_RESET );
	else
	DEFAULT_CHAT_FRAME:AddMessage( "|cffffff00GoldCounter|r "..GC_Locale_Text.CHAT_COUNT_RESET_AUTO );
	end

	GoldCounter_Update();

	-- Update tooltip in real-time
	GoldCounter_SetHistoryList();

	if ( FirstInit == false and AutoReset == false ) then
		GC_ResetButtonTooltip:Show();
	end
	----

end

function GC_TranslateMoney()

		local AbsTotal	= tostring( abs( MySavedMoney ) );
		local StrLen	= string.len( AbsTotal );
		
			if StrLen < 3 then -- It's only Coppers
			
					MyMoney.Gold 	= "0";
					MyMoney.Silver	= "00";

				if StrLen == 1 then -- One digit Coppers
				
					MyMoney.Copper	= tostring( AbsTotal );
					MyMoney.Copper  = "0"..MyMoney.Copper;
					
				else -- Two digits Coppers
				
					MyMoney.Copper	= tostring( AbsTotal );
				
				end
			
			elseif StrLen < 5 then -- Silvers and Coppers
			
					MyMoney.Gold 	= "0";
					MyMoney.Copper = string.sub( AbsTotal, StrLen -1 );

				if StrLen == 3 then -- One digit Silvers and two digits Coppers
				
					MyMoney.Silver = string.sub( AbsTotal, 1, 1 );
					
						MyMoney.Silver = "0"..MyMoney.Silver;
				
				else -- Two digits Silvers
				
					MyMoney.Silver = string.sub( AbsTotal, 1, 2 );
				
				end
				
			else -- There is gold in the river

					MyMoney.Copper = string.sub( AbsTotal, StrLen -1 );
					MyMoney.Silver = string.sub( AbsTotal, StrLen -3, StrLen -2 );

				if StrLen == 5 then -- One digit Gold
				
					MyMoney.Gold 	= string.sub( AbsTotal, 1, 1 );

				else -- More gold
				
					MyMoney.Gold 	= string.sub( AbsTotal, 1, StrLen -4 );

				end
				
			end
			
			GoldCounter_Update();
end

function GoldCounter_Update()

				if MySavedMoney < 0 then

					MyMoney.Sign = "-";
					MyMoney.Color = Money_NegColor;

				elseif MySavedMoney > 0 then

					MyMoney.Sign = "+";
					MyMoney.Color = Money_PosColor;

				else

					MyMoney.Sign = " ";
					MyMoney.Color = Money_NoColor;

				end

		GC_ShowCoppers:SetText( MyMoney.Color..MyMoney.Copper.."|r" );
		GC_ShowSilvers:SetText( MyMoney.Color..MyMoney.Silver.."|r" );
		GC_ShowGolds:SetText( MyMoney.Color..MyMoney.Sign..MyMoney.Gold.."|r" );

		GC_CurrentFunds = GetMoney();

		if MySavedMoney == 0 then
			GC_ResetButton:Disable();
		else
			GC_ResetButton:Enable();
		end
end

function GoldCounter_CheckDurability()

		--- Check Equipped Weapons Durability
		local WEPS_currentDura, WEPS_maxDura;
		
		local WEP1_currentDura, WEP1_maximumDura = GetInventoryItemDurability( INVSLOT_MAINHAND );
		local WEP2_currentDura, WEP2_maximumDura = GetInventoryItemDurability( INVSLOT_OFFHAND );

		if not WEP1_maximumDura and not WEP2_maximumDura then
		
			GC_Gear_Durability.Equipped_Weapons = GC_Gear_Durability.Color_State_NoGear..GC_Locale_Text.TOOLTIP_INFOS_NOGEAR.."|r";
		else
		
			if WEP1_maximumDura and WEP1_maximumDura > 0 then
				WEPS_maxDura = WEP1_maximumDura;
				WEPS_currentDura = WEP1_currentDura;
			else
				WEPS_maxDura = 0;
				WEPS_currentDura = 0;
			end

			if WEP2_maximumDura and WEP2_maximumDura > 0 then
				WEPS_maxDura = WEPS_maxDura + WEP2_maximumDura;
				WEPS_currentDura = WEPS_currentDura + WEP2_currentDura;
			end

			local Total_WEP_Dura_Perc = floor( ( WEPS_currentDura / WEPS_maxDura ) * 100 );
			
			if Total_WEP_Dura_Perc > 70 then
			
				GC_Gear_Durability.Equipped_Weapons = GC_Gear_Durability.Color_State_GOOD..Total_WEP_Dura_Perc.. "%|r"
				
			elseif Total_WEP_Dura_Perc > 30 then

				GC_Gear_Durability.Equipped_Weapons = GC_Gear_Durability.Color_State_MEDIUM..Total_WEP_Dura_Perc.. "%|r"
			
			else
				GC_Gear_Durability.Equipped_Weapons = GC_Gear_Durability.Color_State_LOW..Total_WEP_Dura_Perc.. "%|r"
			end
			
		end
		
		--- Check Equipped Gear Durability
		local Gear_Table = { };
		local Gear_Max_Dura, Gear_Current_Dura = 0, 0;
		
		Gear_Table[1], Gear_Table[2]   = GetInventoryItemDurability( INVSLOT_HEAD );
		Gear_Table[3], Gear_Table[4]   = GetInventoryItemDurability( INVSLOT_SHOULDER );
		Gear_Table[5], Gear_Table[6]   = GetInventoryItemDurability( INVSLOT_CHEST );
		Gear_Table[7], Gear_Table[8]   = GetInventoryItemDurability( INVSLOT_WAIST );
		Gear_Table[9], Gear_Table[10]  = GetInventoryItemDurability( INVSLOT_LEGS );
		Gear_Table[11], Gear_Table[12] = GetInventoryItemDurability( INVSLOT_FEET );
		Gear_Table[13], Gear_Table[14] = GetInventoryItemDurability( INVSLOT_WRIST );
		Gear_Table[15], Gear_Table[16] = GetInventoryItemDurability( INVSLOT_HAND );
		
		for index = 1, 15, 2 do
			if Gear_Table[index] then Gear_Current_Dura = Gear_Current_Dura + Gear_Table[index]; end
			if Gear_Table[index+1] then Gear_Max_Dura = Gear_Max_Dura + Gear_Table[index+1]; end
		end

		if Gear_Max_Dura == 0 then -- Nothing Equipped
		
			GC_Gear_Durability.Equipped_Stuff = GC_Gear_Durability.Color_State_NoGear..GC_Locale_Text.TOOLTIP_INFOS_NOGEAR.."|r";
			
		else
		
			local Total_Equip_Dura_Perc = floor( ( Gear_Current_Dura / Gear_Max_Dura ) * 100 );
			
			if Total_Equip_Dura_Perc > 70 then
			
				GC_Gear_Durability.Equipped_Stuff = GC_Gear_Durability.Color_State_GOOD..Total_Equip_Dura_Perc.. "%|r"
				
			elseif Total_Equip_Dura_Perc > 30 then

				GC_Gear_Durability.Equipped_Stuff = GC_Gear_Durability.Color_State_MEDIUM..Total_Equip_Dura_Perc.. "%|r"
			
			else
				GC_Gear_Durability.Equipped_Stuff = GC_Gear_Durability.Color_State_LOW..Total_Equip_Dura_Perc.. "%|r"
			end

		end

end

function GC_GetClassColor( Name, Class )

	if ( Class == "WARRIOR" ) then         Name = "|cffC69B6D"..Name.."|r";
	elseif ( Class == "WARLOCK" ) then     Name = "|cff8788EE"..Name.."|r";
	elseif ( Class == "SHAMAN" ) then      Name = "|cff0070DD"..Name.."|r";
	elseif ( Class == "ROGUE" ) then       Name = "|cffFFF468"..Name.."|r";
	elseif ( Class == "PRIEST" ) then      Name = "|cffFFFFFF"..Name.."|r";
	elseif ( Class == "PALADIN" ) then     Name = "|cffF48CBA"..Name.."|r";
	elseif ( Class == "MONK" ) then        Name = "|cff00FF98"..Name.."|r";
	elseif ( Class == "MAGE" ) then        Name = "|cff3FC7EB"..Name.."|r";
	elseif ( Class == "HUNTER" ) then      Name = "|cffAAD372"..Name.."|r";
	elseif ( Class == "EVOKER" ) then      Name = "|cff33937F"..Name.."|r";
	elseif ( Class == "DRUID" ) then       Name = "|cffFF7C0A"..Name.."|r";
	elseif ( Class == "DEMONHUNTER" ) then Name = "|cffA330C9"..Name.."|r";
	elseif ( Class == "DEATHKNIGHT" ) then Name = "|cffC41E3A"..Name.."|r";
	end

	return Name;
end

function GC_GetAddonMessage( data1, data2, data3, data4 ) --- prefix, text, channel, name-realm

		if data1 == "GOLDCOUNTER" then

		local dataType = strsub( data2, 1, 6 );

			if data2 == "QUERY" then

				C_ChatInfo.SendAddonMessage( "GOLDCOUNTER", "ANSWER".."-"..GC_Version, data3 );

			elseif ( dataType == "ANSWER" ) then

				if ( GC_switchQuery == true ) then

				DEFAULT_CHAT_FRAME:AddMessage( "|cff00ffff"..data4 .. "|r - |cffffff00" .. strsub( data2, 8 ) .. "|r - " .. data3 );

				end

			elseif ( dataType == "LOGIN1" and GC_PlayerNormName ~= data4 ) then --- Should not be a self call

				local LOGGED_Ver = strsub( data2, 8 );

				local VerMaj, VerMin, VerSubMin = strsplit( ".", LOGGED_Ver, 3 );

				local VerMajT = tonumber( VerMaj );
				local VerMinT = tonumber( VerMin );
				local VerSubMinT = tonumber( VerSubMin );

				local newVersion = false;
				--- Checking if this is new version
				if GC_VerMaj < VerMajT then
					newVersion = true;
				elseif GC_VerMaj == VerMajT and GC_VerMin < VerMinT then
					newVersion = true;
				elseif GC_VerMaj == VerMajT and GC_VerMin == VerMinT and GC_VerSubMin < VerSubMinT then
					newVersion = true;
				end

				if ( newVersion == true and GC_VerWarnDone == false ) then

					--- Switch key to avoid quick unexpected multi-calls from event
					GoldCounter_MainFrame:UnregisterEvent( "GUILD_ROSTER_UPDATE" );
					GC_VerWarnDone = true;

					DEFAULT_CHAT_FRAME:AddMessage( "|cffffff00GoldCounter:|r ".. GC_Locale_Text.MSG_NEWVERSION.. " ( "..LOGGED_Ver.." )" );

				end

			end

		end
end
