---------
---
--- GoldCounter by Hexiatröhm
---
---------

--- Saved Variable
MySavedMoney = nil;
MySavedMoneyHistory  = { };
My_GC_Settings = { };
My_GC_Settings_Local = { };

My_GC_CharMoneyDB = { };
---

--- Global Data
GC_WOW_isRetail, GC_WOW_isVanillaTBC, GC_WOW_isWOTLK = false, false, false;

GC_Version = nil;
GC_VerMaj, GC_VerMin, GC_VerSubMin = 0,0,0;
GC_switchQuery, GC_VerWarnDone = false, false;
GC_PlayerName, GC_PlayerRealm, GC_PlayerNormName, GC_PlayerNormRealm, GC_PlayerClass, GC_PlayerFaction = "?", "?", "?", "?", "?", "?";

GC_MyAsset = 0;
GC_CurrentFunds = 0;
Money_NoColor	= "|cffE0E0E0";
Money_PosColor	= "|cff00ff00";
Money_NegColor	= "|cffff0000";

GC_Gear_Durability = { 

		["Equipped_Stuff"]     = "??",
		["Equipped_Weapons"]   = "??",
		["Color_State_LOW"]    = "|cfff00000",
		["Color_State_MEDIUM"] = "|cfff0f000",
		["Color_State_GOOD"]   = "|cff00f000",
		["Color_State_NoGear"] = "|cff606060";
};
		
MyMoney = {	
		["Gold"]   = 0,
		["Silver"] = 0,
		["Copper"] = 0,
		["Sign"]   = 0,
		["Color"]  = Money_NoColor;
};

GC_CounterFonts_List = {
		
		"SystemFont_Outline",
		"Game12Font",
		"Game13Font",
		"Game15Font",
		"Game18Font",
		"Game12Font_o1",
		"Game13Font_o1",
		"Game15Font_o1",
		"FriendsFont_Small",
		"FriendsFont_Large",
		"FriendsFont_UserText",
		"NumberFont_GameNormal",
		"NumberFont_Shadow_Small",
		"NumberFont_OutlineThick_Mono_Small",
		"NumberFont_Shadow_Med",
		"NumberFont_Outline_Med",
		"NumberFont_Outline_Large",
		"MailFont_Large",
		"Fancy16Font",
		"Fancy18Font",
		"Fancy22Font",
		"Fancy24Font",
		"QuestFont_Shadow_Small",
		"QuestFont_Shadow_Huge",
		"QuestFont_Outline_Huge";
		};

--------------------------------------------------------------------------------------------------------------

function GC_CheckSettings()

	if ( not My_GC_Settings_Local.Scale )         then My_GC_Settings_Local.Scale         = 1;
	end
	if ( not My_GC_Settings_Local.TransView )     then My_GC_Settings_Local.TransView     = false;
	end
	if ( not My_GC_Settings_Local.Font )          then My_GC_Settings_Local.Font          = GC_CounterFonts_List[1];
	end
	if ( not My_GC_Settings_Local.DailyReset )    then My_GC_Settings_Local.DailyReset    = false;
	end
	if ( not My_GC_Settings_Local.LastResetDate ) then My_GC_Settings_Local.LastResetDate = tonumber( date("%y%m%d") );
	end
	if ( not My_GC_Settings_Local.MaxHistoryRec ) then My_GC_Settings_Local.MaxHistoryRec = 8;
	end
	if ( not My_GC_Settings_Local.ShowGoldOnly ) then My_GC_Settings_Local.ShowGoldOnly = false;
	end
	if ( not My_GC_Settings_Local.UseShiftToDrag ) then My_GC_Settings_Local.UseShiftToDrag = false;
	end

	GC_BuildHistoryTable();
end

--------------------------------------------------------------------------------------------------------------

--- Startup OnLoad
function GoldCounter_OnLoad()

	GC_Version = GetAddOnMetadata("GoldCounter", "Version");

	local VerMaj, VerMin, VerSubMin = strsplit( ".", GC_Version, 3 );

	GC_VerMaj    = tonumber( VerMaj );
	GC_VerMin    = tonumber( VerMin );
	GC_VerSubMin = tonumber( VerSubMin );

	GC_WOW_BuildInfo = tonumber( select(4, GetBuildInfo()) );

	--- Determine WOW Expansion
	if WOW_PROJECT_ID == WOW_PROJECT_MAINLINE then
	GC_WOW_isRetail = true;         -- mainline
	elseif WOW_PROJECT_ID == WOW_PROJECT_WRATH_CLASSIC then
	GC_WOW_isWOTLK = true;          -- wrath
	else
	GC_WOW_isVanillaTBC = true;     -- vanilla
	end

	DEFAULT_CHAT_FRAME:AddMessage( "|cffffff00GoldCounter|r version "..GC_Version.." by Hexiatröhm" );
end

--------------------------------------------------------------------------------------------------------------

function GoldCounter_OnEvent( self, event, arg1, arg2, ... )

	--- Is Addon ready? ------------
	if event == "ADDON_LOADED" and arg1 == "GoldCounter" then

		--- Set localized texts
		GC_SetLocaleText();

		--- Check and fix if settings are nil ( after addon update )
		GC_CheckSettings();

		--- Reset button always shows tooltip
		GC_ResetButton:SetMotionScriptsWhileDisabled( true );

		--- Slider Bar setup for Classic
		if ( GC_WOW_isRetail == false ) then
			GC_Options_ScalingSliderLow:SetText("");
			GC_Options_ScalingSliderHigh:SetText("");
		end

		--====== OPTIONS ======
		--- Frame scaling ---
		GC_Options_ScalingSlider:SetValue( My_GC_Settings_Local.Scale );
		GC_Scale_CurrentValue:SetText( My_GC_Settings_Local.Scale );
		GoldCounter_MainFrame:SetScale( My_GC_Settings_Local.Scale );

		--- Use Default or Translucent mode
		GC_ChangeViewMode( My_GC_Settings_Local.TransView );
		GC_Options_CheckButton1:SetChecked( My_GC_Settings_Local.TransView ); --- Check or uncheck button

		--- Only Showing Gold setting
		GC_ShowOnlyGold( My_GC_Settings_Local.ShowGoldOnly );
		GC_Options_CheckButton2:SetChecked( My_GC_Settings_Local.ShowGoldOnly ); --- Check or uncheck button

		--- Use Shift To Drag Option ---
		GC_Options_CheckButton3:SetChecked( My_GC_Settings_Local.UseShiftToDrag ); --- Check or uncheck button

		--- Daily Reset -- Set button
		GC_Options_CheckButton4:SetChecked( My_GC_Settings_Local.DailyReset ); --- Check or uncheck button

		--- Set Numbers font and DropdownList Title
		GC_FontDropDownListCalled( nil, My_GC_Settings_Local.Font );

		--- Set History Lenght in EditBox
		GC_HistListRec_Len:SetNumber( My_GC_Settings_Local.MaxHistoryRec );
		GC_HistListRec_Len:SetCursorPosition(0);
		--=====================

	---  Is it connection or Reload ? ------------ (self, event, isLogin, isReload)
	elseif event == "PLAYER_ENTERING_WORLD" and ( arg1 or arg2 ) then

			GC_MyAsset = GetMoney(); -- Get current funds to balance
			GC_CurrentFunds = GC_MyAsset; -- Store current funds

				--- If SaveVar doesn't exist
				if not MySavedMoney then

					MySavedMoney = 0; --- Init no balance

					-- First time Init - No saved vars = reset to default -- params = AutoReset, FirstInit
					GoldCounter_Reset( false, true );

				else

					GC_MyAsset = GC_MyAsset - MySavedMoney; -- if saved value then modify balance
					GC_TranslateMoney();
				end

	--- Register Addon Messages ( again and again )
	C_ChatInfo.RegisterAddonMessagePrefix( "GOLDCOUNTER" );

	--- Get Character names and build Normalized Name
	GC_PlayerName      = GetUnitName( "player" );
	GC_PlayerNormRealm = GetNormalizedRealmName();
	GC_PlayerNormName  = GC_PlayerName.."-"..GC_PlayerNormRealm;
	GC_PlayerRealm     = GetRealmName();
	_, GC_PlayerClass  = UnitClass( "player" );
	GC_PlayerFaction   = UnitFactionGroup( "player" );

	--- Daily Reset -- Check for today
	if ( My_GC_Settings_Local.DailyReset == true ) then

		local currentDate = tonumber( date("%y%m%d") );

		if ( My_GC_Settings_Local.LastResetDate < currentDate and MySavedMoney ~= 0 ) then

			GoldCounter_Reset( true, false );
		end

			My_GC_Settings_Local.LastResetDate = currentDate;
	end

	--- Update data in DB
	GC_BuildCharactersDB();

	--- Is it money update ? ------------
	elseif event == "PLAYER_MONEY" then
	
		GC_CurrentFunds = GetMoney();
		
			MySavedMoney = ( GC_CurrentFunds - GC_MyAsset );

			GC_TranslateMoney();

	--- Is it receiving addon message ?
	elseif event == "CHAT_MSG_ADDON" then

		GC_GetAddonMessage( arg1, arg2, ... )

	elseif ( event == "UNIT_INVENTORY_CHANGED" ) or ( event == "PLAYER_REGEN_ENABLED" ) then

		GC_switchQuery = false;

	elseif ( event == "GUILD_ROSTER_UPDATE" ) then

		--- Send Version to guild at login or when someone login in guild
		C_ChatInfo.SendAddonMessage( "GOLDCOUNTER", "LOGIN1".."-"..GC_Version, "GUILD" );

	elseif ( event == "PLAYER_LEAVING_WORLD" or event == "PLAYER_LEVEL_UP" ) then

		GC_BuildCharactersDB(); --- Save and update recent data to DB
	end
end

function GC_BuildCharactersDB()

		--- Is there already a DB
		if #My_GC_CharMoneyDB > 0 then

			local fordoTag = false;

			--- Search Existing Character
			for i = 1, #My_GC_CharMoneyDB do

				--- Update Character Data
				if My_GC_CharMoneyDB[i].NormName == GC_PlayerNormName then
					My_GC_CharMoneyDB[i].Balance = MySavedMoney;
					My_GC_CharMoneyDB[i].Funds   = GC_CurrentFunds;
					My_GC_CharMoneyDB[i].Class   = GC_PlayerClass;
					My_GC_CharMoneyDB[i].Level   = UnitLevel( "player" );
					My_GC_CharMoneyDB[i].Faction = GC_PlayerFaction;

					fordoTag = true;
				end

			end

			--- DB exists but Character unknown
			if fordoTag == false then

				--- Add New character
				My_GC_CharMoneyDB[#My_GC_CharMoneyDB+1] = {
						["NormName"] = GC_PlayerNormName,
						["Name"]     = GC_PlayerName,
						["Realm"]    = GC_PlayerRealm,
						["Balance"]  = MySavedMoney,
						["Funds"]    = GC_CurrentFunds,
						["Class"]    = GC_PlayerClass,
						["Level"]    = UnitLevel( "player" ),
					      ["Faction"]  = GC_PlayerFaction;
				}
			end

		else

		--- No DB, create new one
		My_GC_CharMoneyDB = { 
					   {  ["NormName"] = GC_PlayerNormName,
						["Name"]     = GC_PlayerName,
						["Realm"]    = GC_PlayerRealm,
						["Balance"]  = MySavedMoney,
						["Funds"]    = GC_CurrentFunds,
						["Class"]    = GC_PlayerClass,
						["Level"]    = UnitLevel( "player" ),
					      ["Faction"]  = GC_PlayerFaction;

}
					   }; 
		end
end
--------------------------------------------------------------------------------------------------------------

function GC_BuildHistoryTable()

	--- Build Backup Table
	local preSize = #MySavedMoneyHistory;
	local tableBackup = { };
	local index = 1;

	if ( preSize > 0 ) then --- if not first table
		while ( index < preSize and MySavedMoneyHistory[index].date ~= "end" ) do

			tableBackup[index] = { };

			tableBackup[index].date = MySavedMoneyHistory[index].date;
			tableBackup[index].amount = MySavedMoneyHistory[index].amount;

			index = index + 1;
		end

	end
	------------

	--- Build or rebuild History DB
	if ( #MySavedMoneyHistory ~= My_GC_Settings_Local.MaxHistoryRec + 1 ) then

			MySavedMoneyHistory = { };

		for i = 1, My_GC_Settings_Local.MaxHistoryRec do

			MySavedMoneyHistory[i] = { };

			MySavedMoneyHistory[i].date   = nil;
			MySavedMoneyHistory[i].amount = nil;

		end

			MySavedMoneyHistory[My_GC_Settings_Local.MaxHistoryRec+1] = { };
			MySavedMoneyHistory[My_GC_Settings_Local.MaxHistoryRec+1].date   = "end";
			MySavedMoneyHistory[My_GC_Settings_Local.MaxHistoryRec+1].amount = "end";

		--- Clear remaining data when length reduced
		for i = My_GC_Settings_Local.MaxHistoryRec + 2, #MySavedMoneyHistory do

			MySavedMoneyHistory[i] = { };

			MySavedMoneyHistory[i].date   = nil;
			MySavedMoneyHistory[i].amount = nil;
		end

		--- Restore saved data
		if ( preSize > 0 ) then --- It was not the first table
			if ( preSize <= #MySavedMoneyHistory ) then

				for i = 1, #tableBackup do

					MySavedMoneyHistory[i].date   = tableBackup[i].date;
					MySavedMoneyHistory[i].amount = tableBackup[i].amount;

				end

			else

				for i = 1, My_GC_Settings_Local.MaxHistoryRec do

					MySavedMoneyHistory[i].date   = tableBackup[i].date;
					MySavedMoneyHistory[i].amount = tableBackup[i].amount;

				end

			end

		end

	end

end

function GC_ClearHistory()

	for i = 1, My_GC_Settings_Local.MaxHistoryRec, 1 do
	    MySavedMoneyHistory[i].date = nil;
	    MySavedMoneyHistory[i].amount = nil;
	end

	    MySavedMoneyHistory[My_GC_Settings_Local.MaxHistoryRec+1].date = "end";
	    MySavedMoneyHistory[My_GC_Settings_Local.MaxHistoryRec+1].amount = "end";

	DEFAULT_CHAT_FRAME:AddMessage( "|cffffff00GoldCounter|r "..GC_Locale_Text.CHAT_HISTORY_ERASED );

	--- Use appropriate SFX
	if ( GC_WOW_isVanillaTBC == true ) then
		PlaySound( SOUNDKIT.KEY_RING_CLOSE ); --- It's Vanilla/TBC
	elseif ( GC_WOW_isWOTLK == true )  then
		PlaySound( SOUNDKIT.JEWEL_CRAFTING_FINALIZE ); --- It's WOTLK
	else
		PlaySound( SOUNDKIT.UI_TRANSMOGRIFY_REDO ); --- It's Retail
	end

end

function GoldCounter_SetHistoryList()

	GC_ResetButtonTooltip:Hide();

	GC_ResetButtonTooltip:SetOwner( _G["GC_ResetButton"], "ANCHOR_TOPLEFT" );
	GC_ResetButtonTooltip:ClearLines();

	--- Title ---
	GC_ResetButtonTooltipTextLeft1:SetFontObject("Fancy12Font");
	GC_ResetButtonTooltip:AddLine( GC_Locale_Text.TOOLTIP_INFOS_HISTORY ); --- AddLine instead of SetText because bug at first init

	local HistListIndex = 1;

	--- If History then add space line
	if ( MySavedMoneyHistory[1].date ) then

		HistListIndex = HistListIndex + 1;

		_G["GC_ResetButtonTooltipTextLeft"..HistListIndex]:SetFontObject("GameFontWhiteTiny");
		GC_ResetButtonTooltip:AddLine( " " );
	end

	--- Dates and amounts Max to 2 ---
	for i = My_GC_Settings_Local.MaxHistoryRec, 2, -1 do
		if ( MySavedMoneyHistory[i].date ) then

			HistListIndex = HistListIndex + 1;
			_G["GC_ResetButtonTooltipTextLeft"..HistListIndex]:SetFontObject("GameFontWhiteTiny");
			_G["GC_ResetButtonTooltipTextRight"..HistListIndex]:SetFontObject("NumberFont_GameNormal");

			GC_ResetButtonTooltip:AddDoubleLine( MySavedMoneyHistory[i].date, MySavedMoneyHistory[i].amount, 1, 1, 1 );
		end
	end

	HistListIndex = HistListIndex + 1;

	if ( MySavedMoneyHistory[1].date ) then
		_G["GC_ResetButtonTooltipTextLeft"..HistListIndex]:SetFontObject("GameFontWhiteTiny");
		_G["GC_ResetButtonTooltipTextRight"..HistListIndex]:SetFontObject("NumberFont_GameNormal");
		GC_ResetButtonTooltip:AddDoubleLine( MySavedMoneyHistory[1].date, MySavedMoneyHistory[1].amount, nil, nil, nil );
	else
		_G["GC_ResetButtonTooltipTextLeft"..HistListIndex]:SetFontObject("GameFontWhiteTiny");
		GC_ResetButtonTooltip:AddLine( GC_Gear_Durability.Color_State_NoGear..GC_Locale_Text.TOOLTIP_INFOS_NOHIST.."|r" );
	end

	if ( GC_ResetButton:IsEnabled() ) then
	--- Add space ---
	HistListIndex = HistListIndex +1;
	_G["GC_ResetButtonTooltipTextLeft"..HistListIndex]:SetFontObject("GameFontWhiteTiny");
	GC_ResetButtonTooltip:AddLine( " " );

	--- Click Reset Message ---
	_G["GC_ResetButtonTooltipTextLeft".. HistListIndex + 1]:SetFontObject("GameFontWhiteTiny");
	GC_ResetButtonTooltip:AddLine( GC_Locale_Text.TOOLTIP_RESET, 1, 1, 1, 1, true );
	end
end

function GC_MinViewShowAllSetTooltip()

			GC_MinViewShowAllTooltip:SetOwner( _G["GoldCounter_MainFrame"], "ANCHOR_BOTTOM", 50, 0 );
			GC_MinViewShowAllTooltip:ClearLines();

			local fullViewStr = GetCoinTextureString( abs( MySavedMoney ), 12 );

			fullViewStr = MyMoney.Color..MyMoney.Sign..fullViewStr.."|r";

			GC_MinViewShowAllTooltipTextLeft1:SetFontObject("GameFontWhiteTiny");
			GC_MinViewShowAllTooltip:AddLine( fullViewStr, 1, 1, 1 );

			GC_MinViewShowAllTooltip:Show();
end
