---------
---
--- GoldCounter (Options) by Hexiatröhm
---
---------

function GC_ChangeViewMode( switch )

	if switch == true then

		GC_Frame_TL:SetAtlas( nil );
		GC_Frame_TR:SetAtlas( nil );
		GC_Frame_BL:SetAtlas( nil );
		GC_Frame_BR:SetAtlas( nil );
		GC_Frame_T:SetAtlas( nil );
		GC_Frame_B:SetAtlas( nil );

		GC_InfosGearButton:SetPoint( "LEFT", "GoldCounter_MainFrame", "LEFT", "214", "0" );
		GoldCounter_MainFrame:SetClampedToScreen( false );

	else

		GC_Frame_TL:SetAtlas( "chatbubble-nineslice-cornertopleft" );
		GC_Frame_TR:SetAtlas( "chatbubble-nineslice-cornertopright" );
		GC_Frame_BL:SetAtlas( "chatbubble-nineslice-cornerbottomleft" );
		GC_Frame_BR:SetAtlas( "chatbubble-nineslice-cornerbottomright" );
		GC_Frame_T:SetAtlas( "_chatbubble-nineslice-edgetop" );
		GC_Frame_B:SetAtlas( "_chatbubble-nineslice-edgebottom" );

		GC_InfosGearButton:SetPoint( "LEFT", "GoldCounter_MainFrame", "LEFT", "6", "0" );
		GoldCounter_MainFrame:SetClampedToScreen( true );

	end

end

function GC_ShowOnlyGold( switch )

	if ( switch == true ) then

		GC_CopperButton:Hide();
		GC_ShowCoppers:Hide();

		GC_SilverButton:Hide();
		GC_ShowSilvers:Hide();

		GC_GoldButton:SetPoint( "RIGHT", "GC_CopperButton", "LEFT", "14", "0" );

	else
		GC_CopperButton:Show();
		GC_ShowCoppers:Show();

		GC_SilverButton:Show();
		GC_ShowSilvers:Show();

		GC_GoldButton:SetPoint( "RIGHT", "GC_SilverButton", "LEFT", "-24", "0" );

		GoldCounter_MainFrame:SetMouseClickEnabled( true );
	end

end

function GC_FontDropDownListCalled( self, arg1, arg2, checked )

		--- If no default font set default font
		if ( arg1 == nil ) then My_GC_Settings_Local.Font = GC_CounterFonts_List[1]; 
		else My_GC_Settings_Local.Font = arg1;
		end
		
		UIDropDownMenu_SetText( GC_FontDropDownList, My_GC_Settings_Local.Font );

		GC_ShowGolds:SetFontObject( My_GC_Settings_Local.Font );
		GC_ShowSilvers:SetFontObject( My_GC_Settings_Local.Font );
		GC_ShowCoppers:SetFontObject( My_GC_Settings_Local.Font );

end

function GC_FontDropDownList_Init( frame, level, menuList )

					local info = { };

					for i = 1, #GC_CounterFonts_List do

						info = UIDropDownMenu_CreateInfo();
						info.func  = GC_FontDropDownListCalled;
						info.value = i;

						info.text  = GC_CounterFonts_List[i];
						info.arg1  = info.text;

						--- BUGGY !!! Why ? Selecting an item with info.checked or _SetSelectName creates LUA error in LFG and Guild Notes
---						if GC_CounterFonts_List[i] == My_GC_Settings_Local.Font then info.checked = 1; end

						--- Workaround ---
						if GC_CounterFonts_List[i] == My_GC_Settings_Local.Font then
							info.isTitle = true;
						end
						------

						UIDropDownMenu_AddButton( info, 1 );

					end
end

function GC_EditBox_HistListRec_FocusLost( Var )

	if ( Var < 1 or Var > 99 ) then

		GC_HistListRec_Len:SetNumber( My_GC_Settings_Local.MaxHistoryRec );

	else

		My_GC_Settings_Local.MaxHistoryRec = Var;
		GC_HistListRec_Len:SetNumber( My_GC_Settings_Local.MaxHistoryRec );

		GC_BuildHistoryTable();

	end

end

function GC_ShowAssets()

		local TotalFunds = GC_CurrentFunds;

		GC_InfosAssetsButtonTooltip:SetOwner( _G["GC_InfosAssetsButton"], "ANCHOR_BOTTOM" );
		GC_InfosAssetsButtonTooltip:ClearLines();

		GC_InfosAssetsButtonTooltipTextLeft1:SetFontObject("Fancy12Font");
		GC_InfosAssetsButtonTooltip:AddLine( GC_Locale_Text.TOOLTIP_INFOS_FUNDS);

		GC_InfosAssetsButtonTooltipTextLeft2:SetFontObject("GameFontWhiteTiny");
		GC_InfosAssetsButtonTooltip:AddLine( " ", 1, 1, 1 );

		local ColoredName = GC_GetClassColor( GC_PlayerName, GC_PlayerClass );
		local Funds = "|cffFFFFFF"..GetCoinTextureString( GC_CurrentFunds, 12 ).."|r";
		GC_InfosAssetsButtonTooltipTextLeft3:SetFontObject("GameFontWhiteTiny");
		GC_InfosAssetsButtonTooltipTextRight3:SetFontObject("FriendsFont_Small");
		GC_InfosAssetsButtonTooltip:AddDoubleLine( ColoredName.." (".. UnitLevel( "player" ) ..")", Funds, 1, 1, 1 );

		--- For Retail - Add Faction Icon
		if GC_WOW_isRetail == true then

			if GC_PlayerFaction == "Alliance" then
			GC_InfosAssetsButtonTooltip:AddTexture( "communities-create-button-wow-alliance", { width = 8, height = 10, margin = { left = 0, right = 2, top = 0, bottom = 0 } } );
			else
			GC_InfosAssetsButtonTooltip:AddTexture( "communities-create-button-wow-horde", { width = 8, height = 10, margin = { left = 0, right = 2, top = 0, bottom = 0 } } );
			end

		else --- For Classic

			if GC_PlayerFaction == "Alliance" then
			GC_InfosAssetsButtonTooltip:AddTexture( "Interface/PVPFrame/PVP-Currency-Alliance" );
			else
			GC_InfosAssetsButtonTooltip:AddTexture( "Interface/PVPFrame/PVP-Currency-Horde" );
			end

		end
		---

		GC_InfosAssetsButtonTooltipTextLeft4:SetFontObject("GameFontWhiteTiny");
		GC_InfosAssetsButtonTooltip:AddLine( "________________________________________", 1, 1, 1 );
		GC_InfosAssetsButtonTooltipTextLeft5:SetFontObject("GameFontWhiteTiny");
		GC_InfosAssetsButtonTooltip:AddLine( " ", 1, 1, 1 );

		--- Scan how many chars in the current server
		local ScanIndex = 0;
		for i = 1, #My_GC_CharMoneyDB do

			if ( My_GC_CharMoneyDB[i].Realm == GC_PlayerRealm ) then ScanIndex = ScanIndex + 1;
			end

		end

		local FontsIndex = 5;

		if ( #My_GC_CharMoneyDB > 1 and ScanIndex > 1 ) then

			for i = 1, #My_GC_CharMoneyDB do

				if My_GC_CharMoneyDB[i].NormName ~= GC_PlayerNormName and My_GC_CharMoneyDB[i].Realm == GC_PlayerRealm then

					ColoredName = GC_GetClassColor( My_GC_CharMoneyDB[i].Name, My_GC_CharMoneyDB[i].Class );
					Funds = GetCoinTextureString( My_GC_CharMoneyDB[i].Funds, 12 );
					Funds = "|cffFFFFFF"..Funds.."|r";
					TotalFunds = TotalFunds + My_GC_CharMoneyDB[i].Funds;

					FontsIndex = FontsIndex + 1;

				_G["GC_InfosAssetsButtonTooltipTextLeft"..FontsIndex]:SetFontObject("GameFontWhiteTiny");
				_G["GC_InfosAssetsButtonTooltipTextRight"..FontsIndex]:SetFontObject("FriendsFont_Small");
				GC_InfosAssetsButtonTooltip:AddDoubleLine( ColoredName.." (".. My_GC_CharMoneyDB[i].Level ..")", Funds, 1, 1, 1 );

				--- Faction Icons
				if GC_WOW_isRetail == true then

					if My_GC_CharMoneyDB[i].Faction == "Alliance" then
					GC_InfosAssetsButtonTooltip:AddTexture( "communities-create-button-wow-alliance", { width = 8, height = 10, margin = { left = 0, right = 2, top = 0, bottom = 0 } } );
					elseif My_GC_CharMoneyDB[i].Faction == "Horde" then
					GC_InfosAssetsButtonTooltip:AddTexture( "communities-create-button-wow-horde", { width = 8, height = 10, margin = { left = 0, right = 2, top = 0, bottom = 0 } } );
					else
					GC_InfosAssetsButtonTooltip:AddTexture( "QuestTurnin", { width = 9, height = 9, margin = { left = 0, right = 0, top = 0, bottom = 0 } } );
					end

				else --- For Classic

					if ( My_GC_CharMoneyDB[i].Faction == "Alliance" ) then
					GC_InfosAssetsButtonTooltip:AddTexture( "Interface/PVPFrame/PVP-Currency-Alliance" );
					elseif ( My_GC_CharMoneyDB[i].Faction == "Horde" ) then
					GC_InfosAssetsButtonTooltip:AddTexture( "Interface/PVPFrame/PVP-Currency-Horde" );
					end
				end

				end

			end

			FontsIndex = FontsIndex + 1;

			_G["GC_InfosAssetsButtonTooltipTextLeft"..FontsIndex]:SetFontObject("GameFontWhiteTiny");
		GC_InfosAssetsButtonTooltip:AddLine( "________________________________________", 1, 1, 1 );

			FontsIndex = FontsIndex + 1;

			TotalFunds = GetCoinTextureString( TotalFunds, 12 );
			_G["GC_InfosAssetsButtonTooltipTextLeft"..FontsIndex]:SetFontObject("GameFontWhiteTiny");
			GC_InfosAssetsButtonTooltip:AddLine( " ", 1, 1, 1 );

			FontsIndex = FontsIndex + 1;

			_G["GC_InfosAssetsButtonTooltipTextLeft"..FontsIndex]:SetFontObject("GameFontWhiteTiny");
			_G["GC_InfosAssetsButtonTooltipTextRight"..FontsIndex]:SetFontObject("FriendsFont_Small");
			GC_InfosAssetsButtonTooltip:AddDoubleLine( GC_Locale_Text.TOOLTIP_INFOS_TOTAL, TotalFunds, 1, 1, 1 );

		else

		FontsIndex = FontsIndex + 1;
		_G["GC_InfosAssetsButtonTooltipTextLeft"..FontsIndex]:SetFontObject("GameFontWhiteTiny");
		GC_InfosAssetsButtonTooltip:AddLine( GC_Gear_Durability.Color_State_NoGear..GC_Locale_Text.TOOLTIP_INFOS_NODATA.."|r" );

		end

end
